<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:tpl="http://software.in2p3.fr/lavoisier/template.xsd"
                xmlns="http://www.w3.org/1999/xhtml">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="@tpl:extends"/>
    <xsl:template match="@*">
        <xsl:copy/>
    </xsl:template>

    <xsl:template match="*[@tpl:include]">
        <xsl:apply-templates select="document(@tpl:include)/*"/>
    </xsl:template>

    <xsl:template match="*">
        <xsl:param name="extended" select="document(@tpl:extends)/*"/>
        <xsl:variable name="main" select="."/>
        <xsl:copy>
            <xsl:apply-templates select="$extended/@*[not(name()=name(current()))] | @*"/>
            <xsl:for-each select="$extended/*">
                <xsl:if test="(@id and not($main/*[@id=current()/@id])) or (not(@id) and not($main/*[not(@id)][name()=name(current())]))">
                    <xsl:copy-of select="."/>
                </xsl:if>
            </xsl:for-each>
            <xsl:for-each select="*|text()|comment()">
                <xsl:choose>
                    <xsl:when test="$extended/*[@id=current()/@id]">
                        <xsl:apply-templates select=".">
                            <xsl:with-param name="extended" select="$extended/*[@id=current()/@id]"/>
                        </xsl:apply-templates>
                    </xsl:when>
                    <xsl:when test="$extended/*[not(@id)][name()=name(current())]">
                        <xsl:apply-templates select=".">
                            <xsl:with-param name="extended" select="$extended/*[not(@id)][name()=name(current())]"/>
                        </xsl:apply-templates>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:apply-templates select="."/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:for-each>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="comment()">
        <xsl:copy/>
    </xsl:template>
</xsl:stylesheet>